class OptionalFloat extends Object; // inspired by Java's Optional<Float>

var bool Full;
var float content;

static function OptionalFloat Empty()
{
    return New(class'OptionalFloat');
}

static function OptionalFloat Of(float other)
{
    local OptionalFloat res;
    
    res = New(class'OptionalFloat');
    res.content = other;
    res.Full = true;
    
    return res;
}

function bool IsEmpty()
{
    return !Full;
}

function float Get()
{
    if ( !Full )
    {
        Warn("Calling Get on an empty OptionalFloat object, returning default ("$class.default.content$")");
        return class.default.content;
    }
        
    return content;
}